Index: font-lock.el
===================================================================
RCS file: /pack/xemacscvs/XEmacs/xemacs/lisp/font-lock.el,v
retrieving revision 1.29
diff -u -r1.29 font-lock.el
--- lisp/font-lock.el	2005/01/26 04:18:15	1.29
+++ lisp/font-lock.el	2005/02/10 02:41:21
@@ -1640,11 +2324,12 @@
 				font-lock-keywords)))
     (let* ((case-fold-search font-lock-keywords-case-fold-search)
 	   (keywords (cdr font-lock-keywords))
-	   (bufname (buffer-name)) 
+	   (bufname (buffer-name)) (count 0)
+	   keyword matcher highlights
+	   ;; XEmacs addition: for progress gauge
+	   regexp-dots
 	   (progress 5) (old-progress 5)
-	   (iter 0)
-	   (nkeywords (length keywords))
-	   keyword matcher highlights)
+	   (nkeywords (length keywords)))
       ;;
       ;; Fontify each item in `font-lock-keywords' from `start' to `end'.
       ;; In order to measure progress accurately we need to know how
@@ -1652,6 +2337,8 @@
       ;; is ((pos - start)/ (end - start) * nkeywords 
       ;; 	+ iteration / nkeywords) * 100
       (while keywords
+	;; XEmacs: message display is down below.
+	(setq regexp-dots (make-string (incf count) ?.))
 	;;
 	;; Find an occurrence of `matcher' from `start' to `end'.
 	(setq keyword (car keywords) matcher (car keyword))
@@ -1660,78 +2347,78 @@
 		    (if (stringp matcher)
 			(re-search-forward matcher end t)
 		      (funcall matcher end)))
-	  ;; calculate progress
+	  ;; XEmacs: calculate progress, display
 	  (setq progress
 		(+ (/ (* (- (point) start) 95) (* (- end start) nkeywords))
-		   (/ (* iter 95) nkeywords) 5))
+		   (/ (* (1- count) 95) nkeywords) 5))
 	  (when (and loudly (> progress old-progress))
 	    (progress-feedback-with-label 'font-lock
-					  "Fontifying %s... (regexps)"
-					  progress bufname))
+					  "Fontifying %s... (regexps..%s)"
+					  progress bufname regexp-dots))
 	  (setq old-progress progress)
+	  (when (and font-lock-multiline
+		     (>= (point)
+			 (save-excursion (goto-char (match-beginning 0))
+					 (forward-line 1) (point))))
+	    ;; this is a multiline regexp match
+	    ;; (setq font-lock-multiline t)
+	    (put-nonduplicable-text-property
+	     (if (= (point)
+		    (save-excursion
+		      (goto-char (match-beginning 0))
+		      (forward-line 1) (point)))
+		 (1- (point))
+	       (match-beginning 0))
+	     (point)
+	     'font-lock-multiline t))
 	  ;; Apply each highlight to this instance of `matcher', which may be
 	  ;; specific highlights or more keywords anchored to `matcher'.
 	  (setq highlights (cdr keyword))
 	  (while highlights
 	    (if (numberp (car (car highlights)))
+		;; XEmacs addition (next line)
 		(let ((end (match-end (car (car highlights)))))
 		  (font-lock-apply-highlight (car highlights))
-		  ;; restart search just after the end of the
-		  ;; keyword so keywords can share bracketing
-		  ;; expressions.
+		  ;; XEmacs addition (Kyle Jones, 1997): restart search
+		  ;; just after the end of the keyword so keywords can
+		  ;; share bracketing expressions.
 		  (and end (goto-char end)))
 	      (font-lock-fontify-anchored-keywords (car highlights) end))
 	    (setq highlights (cdr highlights))))
-	(setq iter (1+ iter))
 	(setq keywords (cdr keywords))))
     (if loudly
 	(progress-feedback-with-label 'font-lock "Fontifying %s... " 100
 				      (buffer-name)))))
-
-
-;; Various functions.
-
-;; Turn off other related packages if they're on.  I prefer a hook. --sm.
-;; These explicit calls are easier to understand
-;; because people know what they will do.
-;; A hook is a mystery because it might do anything whatever. --rms.
-(defun font-lock-thing-lock-cleanup ()
-  (cond ((and-boundp 'fast-lock-mode fast-lock-mode)
-	 (declare-fboundp (fast-lock-mode -1)))
-	((and-boundp 'lazy-lock-mode lazy-lock-mode)
-	 (declare-fboundp (lazy-lock-mode -1)))
-	((and-boundp 'lazy-shot-mode lazy-shot-mode)
-	 (declare-fboundp (lazy-shot-mode -1)))))
-
-; Do something special for these packages after fontifying.  I prefer a hook.
-(defun font-lock-after-fontify-buffer ()
-  (cond ((and-boundp 'fast-lock-mode fast-lock-mode)
-	 (declare-fboundp (fast-lock-after-fontify-buffer)))
-	((and-boundp 'lazy-lock-mode lazy-lock-mode)
-	 (declare-fboundp (lazy-lock-after-fontify-buffer)))))
 
+;;; End of Keyword regexp fontification functions.
 
 ;; Various functions.
 
 (defun font-lock-compile-keywords (keywords)
-  "Compile KEYWORDS (a list) and return the list of compiled keywords.
-Each keyword has the form (MATCHER HIGHLIGHT ...).  See `font-lock-keywords'."
+  "Compile KEYWORDS into the form (t KEYWORD ...).
+Here KEYWORD is of the form (MATCHER HIGHLIGHT ...) as shown in the
+`font-lock-keywords' doc string."
   (if (eq (car-safe keywords) t)
       keywords
     (cons t (mapcar 'font-lock-compile-keyword keywords))))
 
 (defun font-lock-compile-keyword (keyword)
-  (cond ((nlistp keyword)		; Just MATCHER
+  (cond ((nlistp keyword)			; MATCHER
 	 (list keyword '(0 font-lock-keyword-face)))
-	((eq (car keyword) 'eval)	; Specified (eval . FORM)
+	((eq (car keyword) 'eval)		; (eval . FORM)
 	 (font-lock-compile-keyword (eval (cdr keyword))))
-	((numberp (cdr keyword))	; Specified (MATCHER . MATCH)
+	((eq (car-safe (cdr keyword)) 'quote)	; (MATCHER . 'FORM)
+	 ;; If FORM is a FACENAME then quote it.  Otherwise ignore the quote.
+	 (if (symbolp (nth 2 keyword))
+	     (list (car keyword) (list 0 (cdr keyword)))
+	   (font-lock-compile-keyword (cons (car keyword) (nth 2 keyword)))))
+	((numberp (cdr keyword))		; (MATCHER . MATCH)
 	 (list (car keyword) (list (cdr keyword) 'font-lock-keyword-face)))
-	((symbolp (cdr keyword))	; Specified (MATCHER . FACENAME)
+	((symbolp (cdr keyword))		; (MATCHER . FACENAME)
 	 (list (car keyword) (list 0 (cdr keyword))))
-	((nlistp (nth 1 keyword))	; Specified (MATCHER . HIGHLIGHT)
+	((nlistp (nth 1 keyword))		; (MATCHER . HIGHLIGHT)
 	 (list (car keyword) (cdr keyword)))
-	(t				; Hopefully (MATCHER HIGHLIGHT ...)
+	(t					; (MATCHER HIGHLIGHT ...)
 	 keyword)))
 
 (defun font-lock-eval-keywords (keywords)
@@ -1742,9 +2429,19 @@
 				 (funcall keywords)
 			       (eval keywords)))))
 
+(defun font-lock-value-in-major-mode (alist)
+  "Return value in ALIST for `major-mode', or ALIST if it is not an alist.
+Structure is ((MAJOR-MODE . VALUE) ...) where MAJOR-MODE may be t."
+  (if (consp alist)
+      (cdr (or (assq major-mode alist) (assq t alist)))
+    alist))
+
 (defun font-lock-choose-keywords (keywords level)
-  ;; Return LEVELth element of KEYWORDS.  A LEVEL of nil is equal to a
-  ;; LEVEL of 0, a LEVEL of t is equal to (1- (length KEYWORDS)).
+  "Return LEVELth element of KEYWORDS.
+A LEVEL of nil is equal to a LEVEL of 0, a LEVEL of t is equal to
+\(1- (length KEYWORDS))."
+  ;; XEmacs: This function is rather different because it supports LEVEL
+  ;; being a cons of data, from which we have to extract the correct value.
   (let ((level (if (not (consp level))
 		   level
 		 (cdr (or (assq major-mode level) (assq t level))))))
